(define-module (glicid packages parallel)
  #:use-module (guix packages)
  #:use-module (guix download)
  #:use-module (guix git-download)
  #:use-module (guix build-system gnu)
  #:use-module (guix build-system cmake)
;  #:use-module (guix licenses)
  #:use-module (gnu packages gawk)
  #:use-module (gnu packages gcc)
  #:use-module (gnu packages commencement)
  #:use-module (guix build-system python)
  #:use-module ((guix licenses) #:prefix license:)
  #:use-module ((guix utils) #:select (target-64bit?))
  #:use-module (gnu packages)
  #:use-module (gnu packages admin)
  #:use-module (gnu packages autotools)
  #:use-module (gnu packages base)
  #:use-module (gnu packages freeipmi)
  #:use-module (gnu packages linux)
  #:use-module (gnu packages mpi)
  #:use-module (gnu packages perl)
  #:use-module (gnu packages pkg-config)
  #:use-module (gnu packages parallel)
  #:use-module (gnu packages storage)
  #:use-module (gnu packages networking)
  #:use-module (gnu packages gtk)  
  #:use-module (gnu packages python)
  #:use-module (gnu packages python-science)
  #:use-module (gnu packages python-web)
  #:use-module (gnu packages python-xyz)
  #:use-module (gnu packages readline)
  #:use-module (gnu packages tcl)
  #:use-module (gnu packages tls)
  #:use-module (gnu packages commencement)
  #:use-module (gnu packages gcc)
  #:use-module (gnu packages chemistry)
  #:use-module (gnu packages sphinx)
  #:use-module (srfi srfi-1)
  #:use-module (gnu packages mpi)
  #:use-module (gnu packages sssd)
  #:use-module (gnu packages fabric-management)
  #:use-module (gnu packages benchmark)
  #:use-module (gnu packages messaging)
  #:use-module (gnu packages web)
  #:use-module (gnu packages gnome)
  #:use-module (gnu packages cluster)  
  #:use-module (gnu packages libevent)
  #:use-module (gnu packages xorg)
  #:use-module (gnu packages fontutils)
  #:use-module (gnu packages flex)
  #:use-module (gnu packages bison)
  #:use-module (gnu packages pkg-config)
  #:use-module (gnu packages autotools)
  #:use-module (gnu packages fontutils)
  #:use-module (guix build-system gnu)
  #:use-module (gnu packages image)
  #:use-module (gnu packages maths)     
  #:use-module (guix utils)
  #:use-module (gnu packages cmake)
  #:use-module  (gnu packages pretty-print)
  #:use-module (gnu packages boost)
  #:use-module (gnu packages curl)
  #:use-module (gnu packages cryptsetup)
  #:use-module (gnu packages xml)
  #:use-module (gnu packages admin)
  #:use-module (gnu packages assembly)
  #:use-module (gnu packages authentication)
  #:use-module (gnu packages bdw-gc)
  #:use-module (gnu packages boost) 
  #:use-module (gnu packages compression)
  #:use-module (gnu packages crypto)
  #:use-module (gnu packages cryptsetup)
  #:use-module (gnu packages curl)
  #:use-module (gnu packages databases)
  #:use-module (gnu packages disk)
  #:use-module (gnu packages gperf)
  #:use-module (gnu packages jemalloc)
  #:use-module (gnu packages linux)   
  #:use-module (gnu packages lua)     
  #:use-module (gnu packages ncurses) 
  #:use-module (gnu packages networking)
  #:use-module (gnu packages nss)
  #:use-module (gnu packages openldap)
  #:use-module (gnu packages pkg-config)
  #:use-module (gnu packages python)
  #:use-module (gnu packages python-xyz)
  #:use-module (gnu packages sphinx)
  #:use-module (gnu packages tls)   
  #:use-module (gnu packages web)   
;;  #:use-module (gnu packages glicid)
  #:use-module (gnu packages pretty-print)
  #:use-module (gnu packages virtualization)


)

(define-public glicid-pmix
 (package
  (name "glicid-pmix-3.1.5")
  (version "3.1.5")
   (source 
    (origin
     (method url-fetch)
     (uri (string-append "https://github.com/openpmix/openpmix/releases/download/v" version "/pmix-" version ".tar.bz2"))
     (sha256 (base32 "1xswdkfcrw123ghcr9gmrb852nzjbl4i6qwrid3xyma42yal34w8"))
    )
   )
  (build-system gnu-build-system)
  (arguments
   `(#:configure-flags
     (list
           (string-append "--with-hwloc=" (assoc-ref %build-inputs "hwloc") )
     )
    )
  )
  (synopsis "MPIX lib")
  (description  "MPIX. More to come. FIXIT")
  (home-page "https://www.gnu.org/software/hello/")
  (license license:gpl3+)
  (inputs `(
            ("libevent", libevent)
            ("hwloc" ,hwloc-2 "lib")
            ("perl", perl)
            ("gcc", gcc-11)
           )
  )
 )
)


(define-public glicid-custom-slurm-19.05
 (package 
  (inherit slurm) 
  (name "glicid-custom-slurm-19.05")
  (version "19.05.6")
  (source 
   (origin
    (method url-fetch)
    (uri (string-append "https://download.schedmd.com/slurm/slurm-" version ".tar.bz2"))
    (sha256 (base32 "1kj79r8hng5gp98ickgvj3im4gr19nzd3p3p8g6rl75axb8jin7h"))
   ))
   (arguments
   `(#:configure-flags
     (list "--enable-pam" "--sysconfdir=/etc/slurm"
            "--disable-static"
            (string-append "--with-freeipmi=" (assoc-ref %build-inputs "freeipmi"))
            (string-append "--with-hwloc=" (assoc-ref %build-inputs "hwloc"))
            (string-append "--with-json=" (assoc-ref %build-inputs "json-c"))
            (string-append "--with-munge=" (assoc-ref %build-inputs "munge"))
            (string-append "--with-pmix=" (assoc-ref %build-inputs "glicid-pmix"))

            ;; 32-bit support is marked as deprecated and needs to be
            ;; explicitly enabled.
            ;;;; ,@(if (target-64bit?) '() '("--enable-deprecated"))
      
     )
    )
  )

   (inputs `(("gtk+-2" ,gtk+-2)
             ("gcc", gcc-11)
             ("glicid-pmix", glicid-pmix)
;             ("glicid-specific-openmpi", glicid-specific-openmpi)
                ,@(package-inputs slurm)

   
  ))
  (propagated-inputs
     `(
       ("sssd" ,sssd)
        ))
  
))


(define-public glicid-custom-slurm-20.02
 (package 
  (inherit glicid-custom-slurm-19.05)
  (name "glicid-custom-slurm-20.02")
  (version "20.02.7")
  (source 
   (origin
    (method url-fetch)
    (uri (string-append "https://download.schedmd.com/slurm/slurm-" version ".tar.bz2"))
    (sha256 (base32 "1khlv69q41chgkcs1i7l651hvyx8sz3j9yhjbgky3gpqrgrmz1h6"))
   ))
))


(define-public glicid-custom-slurm-20.11
 (package 
  (inherit glicid-custom-slurm-20.02)
  (name "glicid-custom-slurm-20.11")
  (version "20.11.7")
  (source 
   (origin
    (method url-fetch)
    (uri (string-append "https://download.schedmd.com/slurm/slurm-" version ".tar.bz2"))
    (sha256 (base32 "1fdjihg1x7ks5l77yjv14a4mg6r0v8c3zk1dcxkhrhq3n4dc9nbs"))
   ))
))

(define-public glicid-specific-slurm glicid-custom-slurm-20.02)



